import * as Cheerio from "cheerio";
import * as O from "fp-ts/Option";
import * as Structures from "./structures";
export declare const fromDocument: (markdown: string) => Endpoint[];
export declare const isEndpointSection: (section: string[]) => boolean;
export declare const fromSection: (section: string[]) => {
    route: string;
    description: O.Option<string>;
    method: string;
    url: string;
    params: O.Option<EndpointParams>;
    response: O.Option<EndpointParams>;
};
export declare type Endpoint = ReturnType<typeof fromSection>;
export declare const identifier: (heading: string) => string;
export declare const url: (raw: string) => string;
export interface EndpointParams {
    identifier: string;
    array: boolean;
    structures: Structures.Structure[];
}
export declare const params: ($: Cheerio.CheerioAPI, markdown: string, route: string, hasBody: boolean) => O.Option<EndpointParams>;
export declare const description: ($: Cheerio.CheerioAPI) => O.Option<string>;
export declare const response: ($: Cheerio.CheerioAPI, markdown: string, route: string) => O.Option<EndpointParams>;
export declare const parseResponse: (markdown: string) => O.Option<EndpointParams>;
