"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.value = exports.values = exports.identifier = exports.fromHeader = exports.fromDocument = exports.enumSuffixR = void 0;
const F = __importStar(require("fp-ts/function"));
const O = __importStar(require("fp-ts/Option"));
const R = __importStar(require("remeda"));
const Common = __importStar(require("./common"));
const Arr = __importStar(require("fp-ts/Array"));
exports.enumSuffixR = /(behaviors|enum|events|features|level|modes|opcodes|styles|tier|types?)$/i;
const fromDocument = ($) => $("h2, h6")
    .filter((_, h6) => exports.enumSuffixR.test($(h6).text()))
    .filter((_, el) => Common.hasTable($(el)))
    .map((_, h6) => exports.fromHeader($)($(h6)))
    .toArray();
exports.fromDocument = fromDocument;
const fromHeader = ($) => ($h6) => {
    const $table = Common.table($h6);
    return {
        identifier: exports.identifier($h6.text()),
        values: exports.values($)($table),
    };
};
exports.fromHeader = fromHeader;
const identifier = (heading) => F.pipe(heading.trim(), (heading) => heading.replace(/enum/i, ""), Common.typeify, Common.maybeRename);
exports.identifier = identifier;
const findValueIndex = Common.columnIndex(["id", "value", "integer", "code"]);
const findSecondaryValueIndex = Common.columnIndex(["type"]);
const findNameIndex = Common.columnIndex(["name"]);
const findExplainationIndex = Common.columnIndex(["explaination"]);
const findDescriptionIndex = Common.columnIndex(["description"]);
const values = ($) => ($table) => {
    const $th = $table.find("th");
    const headerCount = $table.find("th").length;
    const valueIndex = F.pipe(findValueIndex($)($th), O.alt(() => findSecondaryValueIndex($)($th)));
    const descriptionIndex = F.pipe(findExplainationIndex($)($th), O.alt(() => findDescriptionIndex($)($th)));
    const nonNameIndexes = [valueIndex, descriptionIndex]
        .filter(O.isSome)
        .map((i) => i.value);
    const unusedIndex = F.pipe([...Array(headerCount).keys()], Arr.findFirst((i) => !nonNameIndexes.includes(i)));
    const nameIndex = F.pipe(findNameIndex($)($th), O.alt(() => unusedIndex), O.getOrElse(() => 0));
    return F.pipe($table
        .find("td")
        .map((_, td) => $(td))
        .toArray(), R.chunk(headerCount), R.map((columns) => exports.value(columns[nameIndex], F.pipe(valueIndex, O.map((i) => columns[i])), F.pipe(descriptionIndex, O.map((i) => columns[i])))));
};
exports.values = values;
const value = ($name, $value, $description) => {
    const name = Common.constantify($name.text());
    const value = F.pipe($value, O.map(($el) => $el.text()), O.getOrElse(() => $name.text().trim()), (val) => (/\d|"/.test(val) ? val : `"${val}"`));
    return {
        name,
        value,
        description: F.pipe($description, O.map(($d) => $d.text())),
    };
};
exports.value = value;
